<?php

class Chater_Chat_Block_Script extends Mage_Core_Block_Template 
{
    // Values from config.
    const PATH_TO_ENEABLED = 'chat_section/chat_group/chater_enable';
    const PATH_TO_CHAT_CODE = 'chat_section/chat_group/chater_code';

    protected function _construct() {
        parent::_construct();
    }
    
    private function parseChatCode() {
        $chatCode = Mage::getStoreConfig(self::PATH_TO_CHAT_CODE);
        
        $chatHash = $this->get_string_between($chatCode, ";z.tok=\"", "\";z");
        return $chatHash;
    }
    
    private function get_string_between($string, $start, $end){
        $string = " ".$string;
        $ini = strpos($string,$start);
        if($ini == 0) return "";
        $ini += strlen($start);
        $len = strpos($string,$end,$ini) - $ini;
        return substr($string,$ini,$len);
    }
    
    public function generateChatCode() {
        $enableChat = (int)Mage::getStoreConfig(self::PATH_TO_ENEABLED);
        
        if($enableChat) {
            $showLogin = '';
            $showEmail = '';

            if(Mage::getSingleton('customer/session')->isLoggedIn()) {
                $customer = Mage::getSingleton('customer/session')->getCustomer();

                $showLogin = 'z.login="' . $customer->getName() . '";';
                $showEmail = 'z.email="' . $customer->getEmail() . '";';
            }
            
            $chatHash = $this->parseChatCode();
        
            $code = '<script type="text/javascript">window.$czater||(function(d,s){var z=$czater=function(c){z._.push(c)},$=z.s=d.createElement(s),e=d.getElementsByTagName(s)[0];z.set=function(o){z.set._.push(o)};z._=[];z.set._=[];$.async=!0;$.setAttribute(\'charset\',\'utf-8\');$.src=\'https://www.chater.biz/assets/modules/chat/js/chat.js\';z.t=+new Date;z.tok="' . $chatHash . '";z.domain="https://www.chater.biz/";' . $showLogin . $showEmail . '$.type=\'text/javascript\';e.parentNode.insertBefore($,e)})(document,\'script\');</script>';
            
            echo $code;
        }
    }
}
